# [Диспетчер](README.en.md)

Создание архива, переключение домена, сохранение скриптов в каталогах проектов и публикация репозиториев на сервере.

| № | Скрипт Bash                                                   | Выполняемые действия                                                              |                    (+)                    |
|:-:|:--------------------------------------------------------------|:----------------------------------------------------------------------------------|:-----------------------------------------:|
| 1 | [**archive_backup.sh**](bash_scripts/archive_backup.sh)       | Создание общего архива для каталогов проектов на текущую дату.                    |  [png](print_screen/archive_backup.png)   |
|   | [archive_cleanup.sh](bash_scripts/archive_cleanup.sh)         | Удаление файлов и папок из каталогов проектов перед восстановлением архива.       |  [png](print_screen/archive_cleanup.png)  |
|   | [archive_packaging.sh](bash_scripts/archive_packaging.sh)     | Сборка вёб-сайтов, упаковка и копирование архивов для развёртывания.              | [gif](print_screen/archive_packaging.gif) |
| 2 | [**info_param.sh**](bash_scripts/info_param.sh)               | Параметр для других скриптов. Переключение домена удалённого репозитория.         |                                           |
|   | [info_references.sh](bash_scripts/info_references.sh)         | Обновление домена удалённого репозитория в перекрёстных ссылках в описаниях.      |  [png](print_screen/info_references.png)  |
|   | [info_tree_license.sh](bash_scripts/info_tree_license.sh)     | Построение дерева каталогов для каждого проекта и копирование файлов лицензии.    | [png](print_screen/info_tree_license.png) |
| 3 | [**repo_compose.sh**](bash_scripts/repo_compose.sh)           | Создание скриптов из шаблонов с параметрами и сохранение их в каталогах проектов. |   [png](print_screen/repo_compose.png)    |
|   | [repo_forgejo.tmpl.sh](bash_scripts/repo_forgejo.tmpl.sh)     | Шаблон скрипта без параметров для создания удалённого репозитория forgejo.        |                                           |
|   | [repo_forgejo2.tmpl.sh](bash_scripts/repo_forgejo2.tmpl.sh)   | Шаблон скрипта без параметров для публикации вёб-сайта на сервере codeberg.       |                                           |
|   | [repo_gitlab.tmpl.sh](bash_scripts/repo_gitlab.tmpl.sh)       | Шаблон скрипта без параметров для создания удалённого репозитория gitlab.         |                                           |
|   | [repo_local.tmpl.sh](bash_scripts/repo_local.tmpl.sh)         | Шаблон скрипта без параметров для создания локального репозитория git.            |                                           |
| 4 | [**suite_orchestrate.sh**](bash_scripts/suite_orchestrate.sh) | Выполнение скриптов. Публикация исходного кода из каталогов проектов.             | [gif](print_screen/suite_orchestrate.gif) |
|   | [suite_pages2.sh](bash_scripts/suite_pages2.sh)               | Выполнение скриптов. Публикация готовых вёб-сайтов на сервере codeberg.           |   [gif](print_screen/suite_pages2.gif)    |
|   | [suite_profile2.sh](bash_scripts/suite_profile2.sh)           | Выполнение скриптов. Публикация оглавлений вёб-сайтов на сервере codeberg.        |  [gif](print_screen/suite_profile2.gif)   |
|   | [suite_testing.sh](bash_scripts/suite_testing.sh)             | Тестирование доступности страниц в вёб-интерфейсе на сервере.                     |   [png](print_screen/suite_testing.png)   |

## Каталоги проектов

Локальные каталоги проектов расположены на одном уровне. На сервере репозитории с вёб-сайтами переходят
в отдельную группу, а остальные репозитории остаются у пользователя. Структура каталогов одинаковая для
[codeberg&period;org](https://codeberg&period;org/golovin),
[git&period;org&period;ru](https://git&period;org&period;ru/golovin) и
[hub&period;mos&period;ru](https://hub&period;mos&period;ru/golovin).

<pre>
.
├─ <a href='https://git.org.ru/golovin/color-tomato-theme/src/branch/master/DIRECTORY_TREE.md'>color-tomato-theme</a>
├─ <a href='https://git.org.ru/golovin/dispatcher/src/branch/master/DIRECTORY_TREE.md'>dispatcher</a>
├─ <a href='https://git.org.ru/golovin/older-tomato-theme/src/branch/master/DIRECTORY_TREE.md'>older-tomato-theme</a>
├─ <a href='https://git.org.ru/golovin/pomodoro/src/branch/master/DIRECTORY_TREE.md'>pomodoro</a>
├─ <a href='https://git.org.ru/pomodoro/1/src/branch/master/DIRECTORY_TREE.md'>pomodoro1</a>
├─ <a href='https://git.org.ru/pomodoro/2/src/branch/master/DIRECTORY_TREE.md'>pomodoro2</a>
├─ <a href='https://git.org.ru/pomodoro/3/src/branch/master/DIRECTORY_TREE.md'>pomodoro3</a>
├─ <a href='https://git.org.ru/pomodoro/4/src/branch/master/DIRECTORY_TREE.md'>pomodoro4</a>
├─ <a href='https://git.org.ru/pomodoro/5/src/branch/master/DIRECTORY_TREE.md'>pomodoro5</a>
└─ <a href='https://git.org.ru/pomodoro/6/src/branch/master/DIRECTORY_TREE.md'>pomodoro6</a>
</pre>
